#include <bits/stdc++.h>
#define int int64_t
#define fi first
#define se second

using namespace std;

int32_t main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int n, m, k; cin >> n >> m >> k;
    if(k != 1) return 0;

    vector<pair<int, int>> v1(n), v2(m);
    for(int i = 0; i < n; i++){
        cin >> v1[i].first >> v1[i].second;
    }

    for(int i = 0; i < m; i++){
        cin >> v2[i].first >> v2[i].second;
    }

    int ans = 1e18;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            int tr = (v1[i].fi - v2[j].fi)*(v1[i].fi - v2[j].fi) + (v1[i].se - v2[j].se)*(v1[i].se - v2[j].se);
            ans = min(ans, tr);
        }
    }

    cout << ans;
    return 0;
}